=== debian/changelog ===
pmemkv (1.1-1) unstable; urgency=medium

  * New upstream release.
    + Make the build reproducible (Closes: #943829; thanks lamby!).
  * Bump {Build,Test}-Dependencies.
  * Update expected test output.
  * Bump symbols.
  * R³.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 31 Jan 2020 20:03:48 +0100

pmemkv (1.0.1-1) unstable; urgency=medium

  * Upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 28 Oct 2019 15:41:46 +0100

pmemkv (1.0.1~rc2-1) experimental; urgency=medium

  * New upstream pre-release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 28 Oct 2019 10:46:46 +0100

pmemkv (1.0.1~rc1-1) experimental; urgency=medium

  * New upstream pre-release.
  * Update soname to 1.
  * Fix autopkgtests wrt --as-needed.
  * Bump B-Dep versions of obj and cpp.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 23 Oct 2019 14:16:49 +0200

pmemkv (0.8-1) experimental; urgency=medium

  * Initial release (Closes: #931240)

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 29 Jun 2019 00:40:22 +0200
